unit u_animation_trigger;

interface

uses
  System.SysUtils, System.Types, System.UITypes, System.Classes, System.Variants,
  FMX.Types, FMX.Controls, FMX.Forms, FMX.Dialogs, FMX.Layouts, FMX.Memo,
  FMX.Ani, FMX.Edit, FMX.Colors;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    enlarge_FloatAnimation: TFloatAnimation;
    Edit1: TEdit;
    amount: TLabel;
    Edit2: TEdit;
    FloatAnimation1: TFloatAnimation;
    shrink_FloatAnimation: TFloatAnimation;
    procedure Edit1MouseEnter(Sender: TObject);
    procedure Edit1MouseLeave(Sender: TObject);
    procedure enlarge_FloatAnimationProcess(Sender: TObject);
    procedure shrink_FloatAnimationProcess(Sender: TObject);
    procedure FloatAnimation1Process(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

    var g_step: Integer= 0;

    procedure display(p_text: String);
      begin
        Form1.Memo1.Lines.Add(p_text);
      end; // display

{$R *.fmx}

    procedure TForm1.Edit1MouseEnter(Sender: TObject);
      begin
        display('OnEnter');
      end;

    procedure TForm1.Edit1MouseLeave(Sender: TObject);
      begin
        display('OnLeave');
      end;

    procedure TForm1.enlarge_FloatAnimationProcess(Sender: TObject);
      begin
        display(Format('step %3d  grow width %5.0f', [g_step, Edit1.Width]));
        Inc(g_step);
      end; //

    procedure TForm1.shrink_FloatAnimationProcess(Sender: TObject);
      begin
        display(Format('step %3d  shrink width%5.0f', [g_step, Edit1.Width]));
        Inc(g_step);
      end; //

    procedure TForm1.FloatAnimation1Process(Sender: TObject);
      begin
        display(Format('step %3d  change width%5.0f', [g_step, Edit2.Width]));
        Inc(g_step);
      end; // FloatAnimation1Process




end.
